﻿using Syncfusion.TreeView.Engine;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace GettingStartedBound
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
            treeView.ItemTapped += TreeView_ItemTapped;
        }

        private void TreeView_ItemTapped(object sender, Syncfusion.XForms.TreeView.ItemTappedEventArgs e)
        {
            var node = e.Node as TreeViewNode;
             (node.Content as FileManager).ItemName = "My New Node";
            //viewModel.ImageNodeInfo[2].ItemName = "MyNew Node";
        }

        private void Handle_Clicked(object sender, System.EventArgs e)
        {
            Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;

            var t = new FileManager() { ItemName = "NEW ITEM", ImageIcon = ImageSource.FromResource("GettingStartedBound.Icons.treeview_folder.png", assembly) };
            var games = new FileManager() { ItemName = "Game.exe", ImageIcon = ImageSource.FromResource("GettingStartedBound.Icons.treeview_exe.png", assembly) };

            t.SubFiles = new ObservableCollection<FileManager>
            {
                games
            };

            viewModel.ImageNodeInfo.Add(t);
        }
    }
}
